package com.xy.config;

import com.dtp.core.support.DynamicTp;
import com.xy.utils.ThreadPoolUtils;
import org.springframework.context.annotation.Bean;
import org.springframework.scheduling.concurrent.ThreadPoolTaskExecutor;
import org.springframework.stereotype.Component;

@Component
public class ThreadPoolConfig {

    public static final String COMMON_POLL = "commonPoll";

    public static final String DEVICE_DATA_SAVE_OR_ACCUM = "deviceDataSaveOrAccum";

    /**
     * 公用线程池
     */
    @DynamicTp
    @Bean(COMMON_POLL)
    public ThreadPoolTaskExecutor commonPoll() {
        return ThreadPoolUtils.newPoll()
                .name(COMMON_POLL)
                .coreSize(10)
                .maxSize(200)
                .keepAlive(60)
                .builder();
    }

    /**
     * 设备统计数据,添加/累加线程池
     */
    @DynamicTp
    @Bean(DEVICE_DATA_SAVE_OR_ACCUM)
    public ThreadPoolTaskExecutor deviceDataSaveOrAccum() {
        return ThreadPoolUtils.newPoll()
                .name(DEVICE_DATA_SAVE_OR_ACCUM)
                .coreSize(10)
                .maxSize(200)
                .keepAlive(60)
                .builder();
    }

}
